#ifndef _GLOBAL_H_
#define	_GLOBAL_H_

#include <stdlib.h>
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#define USE_AND_OR /* To enable AND_OR mask setting */
#include <ports.h>
#include <pps.h>
#include <timer.h>
#include <outcompare.h>
#include <adc.h>

#include "usb_config.h"
#include "USB/usb.h"
#include "USB/usb_host_bluetooth.h"
#include "user.h"
#include "delay.h"
#include "xprintf.h"
#include "btstack/debug.h"

#define BOARD_SBDBT			1
#define BOARD_SBDBT5V		0
#define BOARD_SBXBT			0
#define	BOARD_SBRBT			0
#define	BOARD_SBGRBT		0

#define	UART_PACKET_MULTIPLE_BYTES	0				//UART̃pPbgɕ̃LN^܂߂邩 (konashi݊ɂɂ0)
#define	UART_DEFAULT_BAUDRATE		9600			//UART̃ftHgrbg[g
#define	UART_FIX_BAUDRATE			0				//UART̃rbg[gftHgɌŒ肷邩

#define	I2C_PULLUP_DEFAULT			0				//SCL/SDAftHgœvAbv邩

// Define the baud rate constants UART1
#define	UARTPARAM1			UARTPARAM_N81			//data=8bit parity=none stopbit=1bit

#define BAUDRATE1       	115200
#define	USE_RFCOMM_BAUDRATE	0						//0:baud rate as fixed 1:baud rate as RFCOMM parameter from Master
#define BRG_DIV1        	4
#define BRGH1           	1
// Define Hardware Flow Control UART1 (0:off 1:on)
#define	UART1_HW_FLOW		0

// Define the baud rate constants UART2 (Debug)
#define BAUDRATE2       	115200
#define BRG_DIV2        	4
#define BRGH2           	1

// Define LED1 communication indicator on time(ms)
#define	LED1_ON_COUNT		10
#define	USE_RSSI			1						//0:blink rate as fixed 1:blink rate as RSSI (fast:lowRSSI slow:highRSSI)
#define	USE_WRITE_STORED_LINK_KEY	 1				//SPPڑ̃NL[ 0:PICFLASHɕۑ 1:BluetoothA_v^ɕۑ

#if BOARD_SBDBT
#define LOCAL_NAME			"SBDBT"
#define	ICSDEF				ICS_PGx1
#define	MACHINE_ID			0x33000001
#endif

#if BOARD_SBDBT5V
#define LOCAL_NAME			"SBDBT5V"
#define	ICSDEF				ICS_PGx1
#define	MACHINE_ID			0x50000002
#endif

#if BOARD_SBXBT
#define LOCAL_NAME			"SBXBT"
//#define	ICSDEF				ICS_PGx1
#define	ICSDEF				ICS_PGx3
#define	MACHINE_ID			0x33000003
#endif

#if BOARD_SBRBT
#define LOCAL_NAME			"SBRBT"
#define	ICSDEF				ICS_PGx1
#define	MACHINE_ID			0x50000004
#endif

#if BOARD_SBGRBT
#define LOCAL_NAME			"SBGRBT"
#define	ICSDEF				ICS_PGx1
#define	MACHINE_ID			0x50000005
#endif

#if	__DEBUG
//disable watchdog timer
#define	FWDTENDEF			FWDTEN_OFF
#define	RestartWatchdog()
#define STO_SERIAL			1   //0:STO as I/O  1:STO as serial output
#else
//enable watchdog timer
#define	FWDTENDEF			FWDTEN_ON
#define	RestartWatchdog()	ClrWdt()
#define STO_SERIAL			0   //0:STO as I/O  1:STO as serial output
#endif


#if BOARD_SBDBT | BOARD_SBDBT5V
//
//for SBDBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
#define	u1rx_term()			(RPINR18bits.U1RXR = 0x1f)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)
#define	u1tx_term()			(RPOR11bits.RP22R = 0)
// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

//scl:SBDBT PIN8:RP23/PMA0/CN17/RC7
#define	scl_pullup(x)		(CNPU2bits.CN17PUE=(x))	//x=0:not-pull-up 1:pull-up
#if	I2C_PULLUP_DEFAULT
#define	scl_setup()			(TRISCbits.TRISC7=1,ODCCbits.ODC7=1,LATCbits.LATC7=0,scl_pullup(1))						//input
#else
#define	scl_setup()			(TRISCbits.TRISC7=1,ODCCbits.ODC7=1,LATCbits.LATC7=0)						//input
#endif

#define	ddr_set_scl()		(TRISCbits.TRISC7=0)
#define	ddr_reset_scl()		(TRISCbits.TRISC7=1)
//#define	scl_h_mac()			(LATCbits.LATC7=1)
//#define	scl_l_mac()			(LATCbits.LATC7=0)
#define	scl_h_mac()			ddr_reset_scl()
#define	scl_l_mac()			ddr_set_scl()
#define	get_scl()			(PORTCbits.RC7)

//sda:SBDBT PIN9:RP24/PMA5/CN20/RC8
#define	sda_pullup(x)		(CNPU2bits.CN20PUE=(x))	//x=0:not-pull-up 1:pull-up
#if	I2C_PULLUP_DEFAULT
#define	sda_setup()			(TRISCbits.TRISC8=1,ODCCbits.ODC8=1,LATCbits.LATC8=0,sda_pullup(1))						//input
#else
#define	sda_setup()			(TRISCbits.TRISC8=1,ODCCbits.ODC8=1,LATCbits.LATC8=0)						//input
#endif

#define	ddr_set_sda()		(TRISCbits.TRISC8=0)	//output
#define	ddr_reset_sda()		(TRISCbits.TRISC8=1)	//input
//#define	sda_h()				(LATCbits.LATC8=1)
//#define	sda_l()				(LATCbits.LATC8=0)
#define	sda_h()				ddr_reset_sda()
#define	sda_l()				ddr_set_sda()
#define	get_sda()			(PORTCbits.RC8)

#if	STO_SERIAL
// Configure console OUT(U2TX) - put on pin 1 (RP9)
#define	sto_setup()			(RPOR4bits.RP9R = 5)
#define	sto_l()
#define	sto_h()
#else
// Configure Status OUT - put on pin 1 (RB9)
#define	sto_setup()		(TRISBbits.TRISB9=0)
#define	sto_l()			(LATBbits.LATB9=0)
#define	sto_h()			(LATBbits.LATB9=1)
#endif

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

#define	pairen_setup()
#define	get_pairen()		(1)

#elif BOARD_SBXBT
//
// for SBXBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB15=0)
#define	led1_on()			(LATBbits.LATB15=0)	//ON
#define	led1_off()			(LATBbits.LATB15=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB14=0)
#define	led2_on()			(LATBbits.LATB14=0)	//ON
#define	led2_off()			(LATBbits.LATB14=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
#define	u1rx_term()			(RPINR18bits.U1RXR = 0x1f)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)
#define	u1tx_term()			(RPOR11bits.RP22R = 0)
// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

//scl:SBXBT PIN3:RP23/PMA0/CN17/RC7
#define	scl_pullup(x)		(CNPU2bits.CN17PUE=(x))	//x=0:not-pull-up 1:pull-up
#if	I2C_PULLUP_DEFAULT
#define	scl_setup()			(TRISCbits.TRISC7=1,ODCCbits.ODC7=1,LATCbits.LATC7=0,scl_pullup(1))						//input
#else
#define	scl_setup()			(TRISCbits.TRISC7=1,ODCCbits.ODC7=1,LATCbits.LATC7=0)						//input
#endif

#define	ddr_set_scl()		(TRISCbits.TRISC7=0)
#define	ddr_reset_scl()		(TRISCbits.TRISC7=1)
//#define	scl_h_mac()			(LATCbits.LATC7=1)
//#define	scl_l_mac()			(LATCbits.LATC7=0)
#define	scl_h_mac()			ddr_reset_scl()
#define	scl_l_mac()			ddr_set_scl()
#define	get_scl()			(PORTCbits.RC7)

//sda:SBXBT PIN16:RP24/PMA5/CN20/RC8
#define	sda_pullup(x)		(CNPU2bits.CN20PUE=(x))	//x=0:not-pull-up 1:pull-up
#if	I2C_PULLUP_DEFAULT
#define	sda_setup()			(TRISCbits.TRISC8=1,ODCCbits.ODC8=1,LATCbits.LATC8=0,sda_pullup(1))						//input
#else
#define	sda_setup()			(TRISCbits.TRISC8=1,ODCCbits.ODC8=1,LATCbits.LATC8=0)						//input
#endif

#define	ddr_set_sda()		(TRISCbits.TRISC8=0)	//output
#define	ddr_reset_sda()		(TRISCbits.TRISC8=1)	//input
//#define	sda_h()				(LATCbits.LATC8=1)
//#define	sda_l()				(LATCbits.LATC8=0)
#define	sda_h()				ddr_reset_sda()
#define	sda_l()				ddr_set_sda()
#define	get_sda()			(PORTCbits.RC8)

#if	STO_SERIAL
// Configure console OUT(U2TX) - put on pin 37 (RP20)
#define	sto_setup()			(RPOR10bits.RP20R = 5)
#define	sto_l()
#define	sto_h()
#else
// Configure RSSI(status) OUT - put on pin 37 (RC4)
#define	sto_setup()			(TRISCbits.TRISC4=0)
#define	sto_l()				(LATCbits.LATC4=0)
#define	sto_h()				(LATCbits.LATC4=1)
#endif

// Configure Association OUT - put on pin 20 (RA1)
#define	assoc_setup()		(TRISAbits.TRISA1=0)
#define	assoc_l()			(LATAbits.LATA1=0)
#define	assoc_h()			(LATAbits.LATA1=1)

// Configure ON OUT - put on pin 44 (RB8)
#define	on_setup()			{TRISBbits.TRISB8=0; LATBbits.LATB8=1;}

#define	pairen_setup()
#define	get_pairen()		(1)

#elif BOARD_SBRBT
//
//for SBRBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)


// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

// Configure Pairing enable in - put on pin 1 (RB9)
#define	sto_setup()
#define	sto_l()
#define	sto_h()

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

// Configure Pairing Enable Jumper - on pin 1 (RB9, CN21)
#define	pairen_setup()		{CNPU2bits.CN21PUE=1;}
#define	get_pairen()		(PORTBbits.RB9)

#elif BOARD_SBGRBT
//
//for SBRBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)


// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

// Configure Pairing enable in - put on pin 1 (RB9)
#define	sto_setup()
#define	sto_l()
#define	sto_h()

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

// Configure Pairing Enable Jumper - on pin 1 (RB9, CN21)
#define	pairen_setup()		{CNPU2bits.CN21PUE=1;}
#define	get_pairen()		(!PORTBbits.RB9)

#endif


#define Nop()    __builtin_nop()
#define ClrWdt() {__asm__ volatile ("clrwdt");}
#define Sleep()  {__asm__ volatile ("pwrsav #0");}
#define Idle()   {__asm__ volatile ("pwrsav #1");}
//#define	led1_on_mac()			{led1_on(); led1_on_count=timer_counter; led1_on_state=1;}
#define	led1_on_mac()

extern uint8_t	startup_state;
extern uint8_t	connection_status;
extern unsigned	led1_on_count;
extern uint8_t	led1_on_state;
extern unsigned	timer_counter;
extern WORD		advalue[2];
extern uint8_t	uart1_polarity;

extern void (*usb_tick_handler)(void);
void	event_bluetooth_rxEvent_done(WORD size);
void	event_bluetooth_rxAcl_done(WORD size);
int blemain(void);

//i2c.c
int open_i2c(int speed);
int i2c_start( void );
void i2c_stop( void );
void i2c_ack( void );
void i2c_nak( void );
int i2c_write( int data );
int i2c_read( void );
int i2c_waitbusfree(void);
int send_ctrl(int ctrl );
#endif
